diff --git a/chrome/browser/ui/views/extensions/suspicious_action_config.h b/chrome/browser/ui/views/extensions/suspicious_action_config.h
new file mode 100644
index 000000000000..0617b1ce7172
--- /dev/null
+++ b/chrome/browser/ui/views/extensions/suspicious_action_config.h
@@ -0,0 +1,113 @@
+// Copyright 2014 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CHROME_BROWSER_UI_VIEWS_EXTENSIONS_SUSPICIOUS_ACTION_CONFIG_VIEW_H_
+#define CHROME_BROWSER_UI_VIEWS_EXTENSIONS_SUSPICIOUS_ACTION_CONFIG_VIEW_H_
+
+#include <map>
+#include <stddef.h>
+#include <algorithm>
+#include <string>
+#include <utility>
+#include <vector>
+
+#include "base/memory/weak_ptr.h"
+#include "base/callback_helpers.h"
+#include "base/callback.h"
+#include "base/command_line.h"
+#include "base/compiler_specific.h"
+#include "base/i18n/rtl.h"
+#include "base/macros.h"
+#include "base/metrics/histogram_macros.h"
+#include "base/strings/string_util.h"
+#include "base/strings/utf_string_conversions.h"
+#include "chrome/app/vector_icons/vector_icons.h"
+#include "chrome/browser/browser_process.h"
+#include "chrome/browser/extensions/api/experience_sampling_private/experience_sampling.h"
+#include "chrome/browser/extensions/extension_install_prompt_show_params.h"
+#include "chrome/browser/profiles/profile.h"
+#include "chrome/browser/ui/browser.h"
+#include "chrome/browser/ui/scoped_tabbed_browser_displayer.h"
+#include "chrome/common/extensions/extension_constants.h"
+#include "chrome/grit/generated_resources.h"
+#include "chrome/installer/util/browser_distribution.h"
+#include "components/constrained_window/constrained_window_views.h"
+#include "content/public/browser/browser_thread.h"
+#include "content/public/browser/page_navigator.h"
+#include "content/public/browser/web_contents.h"
+#include "extensions/common/extension.h"
+#include "extensions/common/extension_urls.h"
+#include "ui/base/l10n/l10n_util.h"
+#include "ui/views/controls/button/checkbox.h"
+#include "ui/base/resource/resource_bundle.h"
+#include "ui/gfx/color_palette.h"
+#include "ui/gfx/paint_vector_icon.h"
+#include "ui/gfx/text_utils.h"
+#include "ui/native_theme/common_theme.h"
+#include "ui/views/border.h"
+#include "ui/views/controls/button/image_button.h"
+#include "ui/views/controls/image_view.h"
+#include "ui/views/controls/label.h"
+#include "ui/views/controls/link.h"
+#include "ui/views/controls/scroll_view.h"
+#include "ui/views/controls/separator.h"
+#include "ui/views/layout/box_layout.h"
+#include "ui/views/layout/grid_layout.h"
+#include "ui/views/layout/layout_constants.h"
+#include "ui/views/widget/widget.h"
+#include "ui/base/ui_base_types.h"
+#include "ui/gfx/font_list.h"
+#include "components/url_formatter/elide_url.h"
+#include "content/public/browser/web_contents.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
+#include "extensions/common/extension_set.h"
+#include "extensions/browser/extension_registry.h"
+#include "extensions/common/constants.h"
+#include "extensions/common/manifest_handlers/icons_handler.h"
+#include "extensions/browser/image_loader.h"
+#include "base/bind.h"
+#include "chrome/browser/extensions/extension_util.h"
+#include "extensions/browser/state_store.h"
+#include "chrome/browser/extensions/extension_system_impl.h"
+#include "extensions/browser/state_store.h"
+
+class SuspiciousActionConfig {
+  public:
+    typedef base::Callback<void(bool)> IsActionSuspiciousCallback;
+
+    SuspiciousActionConfig(content::BrowserContext* browser_context) {
+      state_store_ = extensions::ExtensionSystem::Get(browser_context)->state_store();
+    }
+
+    void IsActionSuspicious(
+      const std::string& extension_id,
+      SuspiciousExtensionAction action,
+      const IsActionSuspiciousCallback& callback
+    );
+
+    void SetActionSuspicious(
+      const std::string& extension_id,
+      SuspiciousExtensionAction action,
+      bool is_suspicious
+    );
+
+  private:
+    const char* ExtensionActionToString(SuspiciousExtensionAction action);
+
+    void IsActionSuspiciousReadCallBack(
+      const std::string& extension_id,
+      SuspiciousExtensionAction action,
+      const IsActionSuspiciousCallback& callback,
+      std::unique_ptr<base::Value> value
+    );
+
+    bool IsActionSuspiciousByDefault(SuspiciousExtensionAction action);
+
+    extensions::StateStore* state_store_;
+
+  DISALLOW_COPY_AND_ASSIGN(SuspiciousActionConfig);
+};
+
+#endif  // CHROME_BROWSER_UI_VIEWS_EXTENSIONS_SUSPICIOUS_ACTION_CONFIG_VIEW_H_
diff --git a/chrome/common/extensions/api/developer_private.idl b/chrome/common/extensions/api/developer_private.idl
index 2859a6869d82..fc6a6a9e1aae 100644
--- a/chrome/common/extensions/api/developer_private.idl
+++ b/chrome/common/extensions/api/developer_private.idl
@@ -525,6 +525,11 @@ namespace developerPrivate {
     static void showPermissionsDialog(DOMString extensionId,
                                       optional VoidCallback callback);
 
+    // Opens a suspicious actions dialog.
+    // |extensionId| : The id of the extension to show permissions for.
+    static void showSuspiciousActionsDialog(DOMString extensionId,
+                                            optional VoidCallback callback);
+
     // Reloads a given extension.
     // |extensionId| : The id of the extension to reload.
     // |options| : Additional configuration parameters.
diff --git a/content/browser/frame_host/render_frame_host_delegate.h b/content/browser/frame_host/render_frame_host_delegate.h
index 5079adfb8c41..b9f471ccafc8 100644
--- a/content/browser/frame_host/render_frame_host_delegate.h
+++ b/content/browser/frame_host/render_frame_host_delegate.h
@@ -110,6 +110,14 @@ class CONTENT_EXPORT RenderFrameHostDelegate {
                                    JavaScriptDialogType type,
                                    IPC::Message* reply_msg) {}
 
+  virtual void DisplayExtensionActionPrompt(RenderFrameHost* render_frame_host,
+                                            const base::string16& message,
+                                            const SuspiciousExtensionAction& extension_action,
+                                            const SensitiveElement& sensitive_element,
+                                            const GURL& extension_url,
+                                            const GURL& frame_url,
+                                            IPC::Message* reply_msg) {}
+
   virtual void RunBeforeUnloadConfirm(RenderFrameHost* render_frame_host,
                                       bool is_reload,
                                       IPC::Message* reply_msg) {}
diff --git a/content/browser/frame_host/render_frame_host_impl.cc b/content/browser/frame_host/render_frame_host_impl.cc
index acd26ebd1950..03f73c3b915c 100644
--- a/content/browser/frame_host/render_frame_host_impl.cc
+++ b/content/browser/frame_host/render_frame_host_impl.cc
@@ -798,6 +798,8 @@ bool RenderFrameHostImpl::OnMessageReceived(const IPC::Message &msg) {
                         OnJavaScriptExecuteResponse)
     IPC_MESSAGE_HANDLER(FrameHostMsg_VisualStateResponse,
                         OnVisualStateResponse)
+    IPC_MESSAGE_HANDLER_DELAY_REPLY(FrameHostMsg_DisplayExtensionActionPrompt,
+                                    OnDisplayExtensionActionPrompt)
     IPC_MESSAGE_HANDLER(FrameHostMsg_SmartClipDataExtracted,
                         OnSmartClipDataExtracted)
     IPC_MESSAGE_HANDLER_DELAY_REPLY(FrameHostMsg_RunJavaScriptDialog,
@@ -1867,6 +1869,28 @@ void RenderFrameHostImpl::OnRunJavaScriptDialog(
                                  dialog_type, reply_msg);
 }
 
+void RenderFrameHostImpl::OnDisplayExtensionActionPrompt(
+  const GURL& extension_url,
+  const base::string16& message,
+  const SuspiciousExtensionAction& extension_action,
+  const SensitiveElement& sensitive_element,
+  const GURL& frame_url,
+  IPC::Message* reply_msg) {
+
+  // While a JS message dialog is showing, tabs in the same process shouldn't
+  // process input events.
+  GetProcess()->SetIgnoreInputEvents(true);
+  delegate_->DisplayExtensionActionPrompt(
+    this,
+    message,
+    extension_action,
+    sensitive_element,
+    extension_url,
+    frame_url,
+    reply_msg
+  );
+}
+
 void RenderFrameHostImpl::OnRunBeforeUnloadConfirm(
     const GURL& frame_url,
     bool is_reload,
@@ -3060,6 +3084,12 @@ void RenderFrameHostImpl::SendJavaScriptDialogReply(
   Send(reply_msg);
 }
 
+void RenderFrameHostImpl::ExtensionActionPromptClosed(IPC::Message* reply_msg, bool success) {
+  GetProcess()->SetIgnoreInputEvents(false);
+  FrameHostMsg_DisplayExtensionActionPrompt::WriteReplyParams(reply_msg, success);
+  Send(reply_msg);
+}
+
 // PlzNavigate
 void RenderFrameHostImpl::CommitNavigation(
     ResourceResponse* response,
diff --git a/content/browser/frame_host/render_frame_host_impl.h b/content/browser/frame_host/render_frame_host_impl.h
index 79bf8c2ceb98..40929d80bbcd 100644
--- a/content/browser/frame_host/render_frame_host_impl.h
+++ b/content/browser/frame_host/render_frame_host_impl.h
@@ -467,6 +467,8 @@ class CONTENT_EXPORT RenderFrameHostImpl
                               bool success,
                               const base::string16& user_input);
 
+  void ExtensionActionPromptClosed(IPC::Message* reply_msg, bool success);
+
   // Get the accessibility mode from the delegate and Send a message to the
   // renderer process to change the accessibility mode.
   void UpdateAccessibilityMode();
@@ -725,6 +727,12 @@ class CONTENT_EXPORT RenderFrameHostImpl
   void OnContextMenu(const ContextMenuParams& params);
   void OnJavaScriptExecuteResponse(int id, const base::ListValue& result);
   void OnVisualStateResponse(uint64_t id);
+  void OnDisplayExtensionActionPrompt(const GURL& extension_url,
+                                      const base::string16& message,
+                                      const SuspiciousExtensionAction& extension_action,
+                                      const SensitiveElement& sensitive_element,
+                                      const GURL& frame_url,
+                                      IPC::Message* reply_msg);
   void OnRunJavaScriptDialog(const base::string16& message,
                              const base::string16& default_prompt,
                              const GURL& frame_url,
diff --git a/content/browser/web_contents/web_contents_impl.cc b/content/browser/web_contents/web_contents_impl.cc
index 9a91bc9bb167..f0aff135c31b 100644
--- a/content/browser/web_contents/web_contents_impl.cc
+++ b/content/browser/web_contents/web_contents_impl.cc
@@ -4418,6 +4418,29 @@ void WebContentsImpl::RunJavaScriptDialog(RenderFrameHost* render_frame_host,
   }
 }
 
+void WebContentsImpl::DisplayExtensionActionPrompt(
+  RenderFrameHost* render_frame_host,
+  const base::string16& message,
+  const SuspiciousExtensionAction& extension_action,
+  const SensitiveElement& sensitive_element,
+  const GURL& extension_url,
+  const GURL& frame_url,
+  IPC::Message* reply_msg) {
+  delegate_->ShowExtensionActionPromptView(
+    this,
+    message,
+    extension_action,
+    sensitive_element,
+    extension_url,
+    frame_url,
+    base::Bind(&WebContentsImpl::ExtensionActionPromptClosed,
+               base::Unretained(this),
+               render_frame_host->GetProcess()->GetID(),
+               render_frame_host->GetRoutingID(),
+               reply_msg)
+  );
+}
+
 void WebContentsImpl::RunBeforeUnloadConfirm(
     RenderFrameHost* render_frame_host,
     bool is_reload,
@@ -5329,6 +5352,19 @@ void WebContentsImpl::OnDialogClosed(int render_process_id,
   is_showing_before_unload_dialog_ = false;
 }
 
+void WebContentsImpl::ExtensionActionPromptClosed(int render_process_id,
+                                                  int render_frame_id,
+                                                  IPC::Message* reply_msg,
+                                                  bool success) {
+  RenderFrameHostImpl* rfh = RenderFrameHostImpl::FromID(render_process_id, render_frame_id);
+  if (rfh) {
+    rfh->ExtensionActionPromptClosed(reply_msg, success);
+  } else {
+    // Don't leak the sync IPC reply if the RFH or process is gone.
+    delete reply_msg;
+  }
+}
+
 void WebContentsImpl::SetEncoding(const std::string& encoding) {
   if (encoding == last_reported_encoding_)
     return;
diff --git a/content/browser/web_contents/web_contents_impl.h b/content/browser/web_contents/web_contents_impl.h
index 2eb11eabb52c..21d14887d0db 100644
--- a/content/browser/web_contents/web_contents_impl.h
+++ b/content/browser/web_contents/web_contents_impl.h
@@ -482,6 +482,13 @@ class CONTENT_EXPORT WebContentsImpl
   void RenderFrameDeleted(RenderFrameHost* render_frame_host) override;
   void ShowContextMenu(RenderFrameHost* render_frame_host,
                        const ContextMenuParams& params) override;
+  void DisplayExtensionActionPrompt(RenderFrameHost* render_frame_host,
+                                    const base::string16& message,
+                                    const SuspiciousExtensionAction& extension_action,
+                                    const SensitiveElement& sensitive_element,
+                                    const GURL& extension_url,
+                                    const GURL& frame_url,
+                                    IPC::Message* reply_msg) override;
   void RunJavaScriptDialog(RenderFrameHost* render_frame_host,
                            const base::string16& message,
                            const base::string16& default_prompt,
@@ -1007,6 +1014,11 @@ class CONTENT_EXPORT WebContentsImpl
                       bool success,
                       const base::string16& user_input);
 
+  void ExtensionActionPromptClosed(int render_process_id,
+                                   int render_frame_id,
+                                   IPC::Message* reply_msg,
+                                   bool success);
+
   // IPC message handlers.
   void OnThemeColorChanged(RenderFrameHostImpl* source, SkColor theme_color);
   void OnDidLoadResourceFromMemoryCache(RenderFrameHostImpl* source,
diff --git a/content/common/frame_messages.h b/content/common/frame_messages.h
index ca1ed2d0caf8..8e66fa7cc9f9 100644
--- a/content/common/frame_messages.h
+++ b/content/common/frame_messages.h
@@ -1463,6 +1463,15 @@ IPC_SYNC_MESSAGE_ROUTED4_2(FrameHostMsg_RunJavaScriptDialog,
                            bool /* out - success */,
                            base::string16 /* out - user_input field */)
 
+// A request to display a prompt dialog, asking for permission to perform extension action
+IPC_SYNC_MESSAGE_ROUTED5_1(FrameHostMsg_DisplayExtensionActionPrompt,
+                          GURL               /* in - extension url */,
+                          base::string16     /* in - prompt message */,
+                          SuspiciousExtensionAction     /* in - extension action */,
+                          SensitiveElement                /* in - sensitive_element */,
+                          GURL               /* in - originating page URL */,
+                          bool               /* out - success */)
+
 // Displays a dialog to confirm that the user wants to navigate away from the
 // page. Replies true if yes, and false otherwise. The reply string is ignored,
 // but is included so that we can use OnJavaScriptMessageBoxClosed.
diff --git a/content/public/browser/web_contents_delegate.cc b/content/public/browser/web_contents_delegate.cc
index 6a368e180796..5bba7cef94f4 100644
--- a/content/public/browser/web_contents_delegate.cc
+++ b/content/public/browser/web_contents_delegate.cc
@@ -155,6 +155,14 @@ JavaScriptDialogManager* WebContentsDelegate::GetJavaScriptDialogManager(
   return nullptr;
 }
 
+void WebContentsDelegate::ShowExtensionActionPromptView(WebContents* source,
+                                                        const base::string16& message,
+                                                        const SuspiciousExtensionAction& extension_action,
+                                                        const SensitiveElement& sensitive_element,
+                                                        const GURL& extension_url,
+                                                        const GURL& frame_url,
+                                                        const DialogClosedCallback& callback) {}
+
 std::unique_ptr<BluetoothChooser> WebContentsDelegate::RunBluetoothChooser(
     RenderFrameHost* frame,
     const BluetoothChooser::EventHandler& event_handler) {
diff --git a/content/public/browser/web_contents_delegate.h b/content/public/browser/web_contents_delegate.h
index 232d3a96040b..c89956d346a0 100644
--- a/content/public/browser/web_contents_delegate.h
+++ b/content/public/browser/web_contents_delegate.h
@@ -354,6 +354,16 @@ class CONTENT_EXPORT WebContentsDelegate {
   virtual JavaScriptDialogManager* GetJavaScriptDialogManager(
       WebContents* source);
 
+  typedef base::Callback<void(bool /* success */)> DialogClosedCallback;
+
+  virtual void ShowExtensionActionPromptView(WebContents* source,
+                                             const base::string16& message,
+                                             const SuspiciousExtensionAction& extension_action,
+                                             const SensitiveElement& sensitive_element,
+                                             const GURL& extension_url,
+                                             const GURL& frame_url,
+                                             const DialogClosedCallback& callback);
+
   // Called when color chooser should open. Returns the opened color chooser.
   // Returns nullptr if we failed to open the color chooser (e.g. when there is
   // a ColorChooserDialog already open on Windows). Ownership of the returned
diff --git a/content/renderer/render_frame_impl.cc b/content/renderer/render_frame_impl.cc
index 9243e310abdb..1b525514f150 100644
--- a/content/renderer/render_frame_impl.cc
+++ b/content/renderer/render_frame_impl.cc
@@ -4246,6 +4246,18 @@ bool RenderFrameImpl::RunModalPromptDialog(
   return ok;
 }
 
+bool RenderFrameImpl::DisplayExtensionActionPrompt(const GURL& extension_url,
+                                                   const blink::WebString& message,
+                                                   const SuspiciousExtensionAction& extension_action,
+                                                   const SensitiveElement& sensitive_element) {
+  bool success = true;
+  Send(new FrameHostMsg_DisplayExtensionActionPrompt(
+    routing_id_, extension_url, message.Utf16(), extension_action, sensitive_element,
+    frame_->GetDocument().Url(), &success
+  ));
+  return success;
+}
+
 bool RenderFrameImpl::RunModalBeforeUnloadDialog(bool is_reload) {
   // Don't allow further dialogs if we are waiting to swap out, since the
   // ScopedPageLoadDeferrer in our stack prevents it.
diff --git a/content/renderer/render_frame_impl.h b/content/renderer/render_frame_impl.h
index 37c5efccfc51..56294aacde50 100644
--- a/content/renderer/render_frame_impl.h
+++ b/content/renderer/render_frame_impl.h
@@ -614,6 +614,10 @@ class CONTENT_EXPORT RenderFrameImpl
   bool RunModalPromptDialog(const blink::WebString& message,
                             const blink::WebString& default_value,
                             blink::WebString* actual_value) override;
+  bool DisplayExtensionActionPrompt(const GURL& extension_url,
+                                    const blink::WebString& message,
+                                    const SuspiciousExtensionAction& extension_action,
+                                    const SensitiveElement& sensitive_element) override;
   bool RunModalBeforeUnloadDialog(bool is_reload) override;
   bool RunFileChooser(
       const blink::WebFileChooserParams& params,
diff --git a/third_party/WebKit/Source/bindings/core/v8/ScriptPromiseProperty.h b/third_party/WebKit/Source/bindings/core/v8/ScriptPromiseProperty.h
index 6e095b910ae1..80e1ac9c5fe1 100644
--- a/third_party/WebKit/Source/bindings/core/v8/ScriptPromiseProperty.h
+++ b/third_party/WebKit/Source/bindings/core/v8/ScriptPromiseProperty.h
@@ -131,7 +131,7 @@ template <typename PassRejectedType>
 void ScriptPromiseProperty<HolderType, ResolvedType, RejectedType>::Reject(
     PassRejectedType value) {
   if (GetState() != kPending) {
-    NOTREACHED();
+    //NOTREACHED();
     return;
   }
   if (!GetExecutionContext() || GetExecutionContext()->IsContextDestroyed())
diff --git a/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.cpp b/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.cpp
index e8a8543bb382..983844e21e37 100644
--- a/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.cpp
+++ b/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.cpp
@@ -53,6 +53,7 @@ V8AbstractEventListener::V8AbstractEventListener(bool is_attribute,
       listener_(nullptr),
       is_attribute_(is_attribute),
       world_(world),
+      origin_world_(PassRefPtr<DOMWrapperWorld>(world.GetOriginWorld())),
       isolate_(isolate),
       worker_global_scope_(nullptr) {
   if (IsMainThread())
@@ -95,6 +96,8 @@ void V8AbstractEventListener::handleEvent(ExecutionContext* execution_context,
 void V8AbstractEventListener::HandleEvent(ScriptState* script_state,
                                           Event* event) {
   ScriptState::Scope scope(script_state);
+  // Ensure the origin world gets propagated to the event and is reset afterwards.
+  DOMWrapperWorld::OriginWorldScope worldScope(origin_world_);
 
   // Get the V8 wrapper for the event object.
   v8::Local<v8::Value> js_event =
diff --git a/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.h b/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.h
index a99866ac5344..a2b71123fdb9 100644
--- a/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.h
+++ b/third_party/WebKit/Source/bindings/core/v8/V8AbstractEventListener.h
@@ -147,6 +147,7 @@ class CORE_EXPORT V8AbstractEventListener : public EventListener,
   bool is_attribute_;
 
   RefPtr<DOMWrapperWorld> world_;
+  RefPtr<DOMWrapperWorld> origin_world_;
   v8::Isolate* isolate_;
 
   // nullptr unless this listener belongs to a worker.
diff --git a/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.cpp b/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.cpp
index 3b4360254fd6..8cecee68f9c8 100644
--- a/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.cpp
+++ b/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.cpp
@@ -40,7 +40,10 @@ V8MutationCallback::V8MutationCallback(v8::Local<v8::Function> callback,
                                        v8::Local<v8::Object> owner,
                                        ScriptState* script_state)
     : callback_(script_state->GetIsolate(), this, callback),
-      script_state_(script_state) {
+      script_state_(script_state),
+      origin_world_(PassRefPtr<DOMWrapperWorld>(
+        DOMWrapperWorld::Current(v8::Isolate::GetCurrent()).GetOriginWorld())
+      ) {
   V8PrivateProperty::GetMutationObserverCallback(script_state->GetIsolate())
       .Set(owner, callback);
 }
@@ -51,6 +54,8 @@ void V8MutationCallback::Call(
     const HeapVector<Member<MutationRecord>>& mutations,
     MutationObserver* observer) {
   v8::Isolate* isolate = script_state_->GetIsolate();
+  // Ensure the origin world gets propagated to the event and is reset afterwards.
+  DOMWrapperWorld::OriginWorldScope worldScope(origin_world_);
   ExecutionContext* execution_context =
       ExecutionContext::From(script_state_.Get());
   if (!execution_context || execution_context->IsContextSuspended() ||
diff --git a/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.h b/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.h
index cdb7f0efb122..b40180226fda 100644
--- a/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.h
+++ b/third_party/WebKit/Source/bindings/core/v8/V8MutationCallback.h
@@ -64,6 +64,7 @@ class V8MutationCallback final : public MutationCallback {
 
   TraceWrapperV8Reference<v8::Function> callback_;
   RefPtr<ScriptState> script_state_;
+  RefPtr<DOMWrapperWorld> origin_world_;
 };
 
 }  // namespace blink
diff --git a/third_party/WebKit/Source/bindings/core/v8/V8ScriptRunner.cpp b/third_party/WebKit/Source/bindings/core/v8/V8ScriptRunner.cpp
index cca9ab4a16dd..101bef9350e0 100644
--- a/third_party/WebKit/Source/bindings/core/v8/V8ScriptRunner.cpp
+++ b/third_party/WebKit/Source/bindings/core/v8/V8ScriptRunner.cpp
@@ -656,6 +656,11 @@ v8::MaybeLocal<v8::Value> V8ScriptRunner::CallFunction(
   ScopedFrameBlamer frame_blamer(frame);
   TRACE_EVENT0("v8", "v8.callFunction");
 
+  // Ensure the origin world gets propagated to the event and is reset afterwards.
+  DOMWrapperWorld::OriginWorldScope worldScope(PassRefPtr<DOMWrapperWorld>(
+    DOMWrapperWorld::Current(v8::Isolate::GetCurrent()).GetOriginWorld()
+  ));
+
   int depth = v8::MicrotasksScope::GetCurrentDepth(isolate);
   if (depth >= kMaxRecursionDepth)
     return v8::MaybeLocal<v8::Value>(
